"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IframeProviderContentWindow = void 0;
const constants_1 = require("../constants");
const IframeManager_styles_1 = require("./IframeManager.styles");
class IframeProviderContentWindow {
    constructor(props) {
        var _a, _b, _c, _d, _e, _f, _g;
        this.walletAddress = '';
        const { id, url, anchor } = props;
        this.container = (_a = constants_1.safeDocument.createElement) === null || _a === void 0 ? void 0 : _a.call(constants_1.safeDocument, 'div');
        this.header = (_b = constants_1.safeDocument.createElement) === null || _b === void 0 ? void 0 : _b.call(constants_1.safeDocument, 'div');
        this.title = (_c = constants_1.safeDocument.createElement) === null || _c === void 0 ? void 0 : _c.call(constants_1.safeDocument, 'div');
        this.body = (_d = constants_1.safeDocument.createElement) === null || _d === void 0 ? void 0 : _d.call(constants_1.safeDocument, 'div');
        this.iframe = (_e = constants_1.safeDocument.createElement) === null || _e === void 0 ? void 0 : _e.call(constants_1.safeDocument, 'iframe');
        this.iframe.allow = 'publickey-credentials-get *';
        console.log('herererere!@!#!@#! creating content window111');
        this.buildWindow(id, url);
        this.contentWindow = this.iframe.contentWindow;
        this.setupWindow();
        if (anchor) {
            anchor.appendChild(this.container);
        }
        else {
            (_g = (_f = constants_1.safeDocument.body) === null || _f === void 0 ? void 0 : _f.appendChild) === null || _g === void 0 ? void 0 : _g.call(_f, this.container);
        }
    }
    buildWindow(id, url) {
        this.container.id = `window-container-${id}`;
        this.iframe.id = id;
        this.iframe.src = url;
        this.container.style.cssText = IframeManager_styles_1.containerStyle;
        this.header.style.cssText = IframeManager_styles_1.headerStyle;
        this.body.style.cssText = IframeManager_styles_1.bodyStyle;
        this.iframe.style.cssText = IframeManager_styles_1.iframeStyle;
        this.buildContainer();
    }
    buildHeader() {
        var _a, _b, _c;
        const iframeIcon = '<img src="https://developer.apple.com/assets/elements/icons/passkeys/passkeys-96x96_2x.png" class="icon-passkeys center" width="50" alt="" data-hires-status="pending">';
        const toggleIcon = '<svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="arrow-right-to-line" class="svg-inline--fa fa-arrow-right-to-line " role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" style="width: 20px;color: #737373;"><path fill="currentColor" d="M448 88c0-13.3-10.7-24-24-24s-24 10.7-24 24l0 336c0 13.3 10.7 24 24 24s24-10.7 24-24l0-336zM312.4 273.5c4.8-4.5 7.6-10.9 7.6-17.5s-2.7-12.9-7.6-17.5l-136-128c-9.7-9.1-24.8-8.6-33.9 1s-8.6 24.8 1 33.9L235.5 232 152 232 24 232c-13.3 0-24 10.7-24 24s10.7 24 24 24l128 0 83.5 0-91.9 86.5c-9.7 9.1-10.1 24.3-1 33.9s24.3 10.1 33.9 1l136-128z"></path></svg>';
        const headingElement = (_a = constants_1.safeDocument.createElement) === null || _a === void 0 ? void 0 : _a.call(constants_1.safeDocument, 'div');
        const iframeIconElement = (_b = constants_1.safeDocument.createElement) === null || _b === void 0 ? void 0 : _b.call(constants_1.safeDocument, 'div');
        const toggleIconElement = (_c = constants_1.safeDocument.createElement) === null || _c === void 0 ? void 0 : _c.call(constants_1.safeDocument, 'div');
        iframeIconElement.innerHTML = iframeIcon;
        toggleIconElement.innerHTML = toggleIcon;
        toggleIconElement.style.cssText = IframeManager_styles_1.toggleIconElementStyle;
        this.title.innerText = 'Passkey Login';
        this.title.style.cssText = IframeManager_styles_1.titleElementStyle;
        headingElement.id = 'mx-wallet-iframe-window-toggle-button';
        headingElement.style.cssText = IframeManager_styles_1.headingElementStyle;
        headingElement.appendChild(iframeIconElement);
        headingElement.appendChild(this.title);
        headingElement.appendChild(toggleIconElement);
        headingElement.onclick = () => {
            if (this.body.style.visibility === 'visible') {
                this.forceHidden();
                return;
            }
            this.forceVisible();
        };
        this.header.appendChild(headingElement);
    }
    buildContainer() {
        this.container.appendChild(this.header);
        this.container.appendChild(this.body);
        this.body.appendChild(this.iframe);
        this.buildHeader();
    }
    setupWindow() {
        this.iframe.onload = () => {
            this.contentWindow = this.iframe.contentWindow;
            const event = new CustomEvent(constants_1.iframeWindowReadyEvent, {
                detail: this.iframe
            });
            this.iframe.dispatchEvent(event);
        };
    }
    forceVisible() {
        this.body.style.visibility = 'visible';
        this.container.style.visibility = 'visible';
        this.container.style.height = 'calc(100vh - 64px - 8px)';
        this.container.style.transform = 'translateX(0)';
        this.title.style.opacity = '1';
    }
    forceHidden() {
        this.body.style.visibility = 'hidden';
        this.container.style.height = '80px';
        this.container.style.transform =
            'translateX(calc(min(420px, 100vw - 8px) - 80px)';
        this.title.style.opacity = '0';
    }
    getContainer() {
        return this.container;
    }
    getIframe() {
        return this.iframe;
    }
    getContentWindow() {
        return this.contentWindow;
    }
    setUrl(url) {
        this.iframe.setAttribute('src', url);
    }
    remove() {
        this.container.remove();
    }
    setWalletVisible(visible) {
        if (visible) {
            this.forceVisible();
            return;
        }
        this.forceHidden();
    }
    addEventListener(type, listener) {
        this.iframe.addEventListener(type, listener);
    }
}
exports.IframeProviderContentWindow = IframeProviderContentWindow;
//# sourceMappingURL=IframeProviderContentWindow.js.map